#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "Fish_DiceFishCFG.h"
#include "FileEncrypt.h"
std::auto_ptr<Fish_DiceFishCFG> Fish_DiceFishCFG::msSingleton(nullptr);

int Fish_DiceFishCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_DiceFishCFGData* Fish_DiceFishCFG::GetData(int Rotation)
{
	auto it = mMapData.find(Rotation);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, Fish_DiceFishCFGData>& Fish_DiceFishCFG::GetMapData()
{
	return mMapData;
}

void Fish_DiceFishCFG::Reload()
{
	mMapData.clear();
	Load();
}

void Fish_DiceFishCFG::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_DiceFishCFGData data;
		data.mRotation = element->IntAttribute("Rotation");
		data.mMagnification = element->IntAttribute("Magnification");
		data.mProbability = element->IntAttribute("Probability");
		if (mMapData.find(data.mRotation) != mMapData.end())std::cout <<"data refind:" << data.mRotation << std::endl;
		assert(mMapData.find(data.mRotation) == mMapData.end());
		mMapData.insert(std::make_pair(data.mRotation, data));
		element = element->NextSiblingElement();
	}
}

void Fish_DiceFishCFG::Load()
{
	Load("../Config/Fish_DiceFishCFG.xml");
}

Fish_DiceFishCFG* Fish_DiceFishCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_DiceFishCFG());
	}
	return msSingleton.get();
}
